# -*- coding: utf-8 -*-
#MoxReplaceSave  161128 saveのチェックを追加
#リファレンスファイルを入れ替え、シーンを保存します。入力のない状態のエラー処理がまだです。

import maya.cmds as cmds
import maya.mel as mm

def setPath_replace():
    multipleFilters = "Maya Files (*.ma *.mb);;Maya ASCII (*.ma);;Maya Binary (*.mb);;All Files (*.*)"
    path = cmds.fileDialog2(fileFilter=multipleFilters, dialogStyle=2, okc="set", fileMode=1)[0]
    cmds.textFieldButtonGrp("RR", e=True, text=path)
    
def setPath_save():
    path = cmds.fileDialog2( dialogStyle=2, okc="set", fileMode=3)[0]
    cmds.textFieldButtonGrp("savePath", e=True, text=path)
    
    
#メイン   
def MRS_main():
    rrn = cmds.textFieldButtonGrp("RR", q=True, text=True)
    savePath = cmds.textFieldButtonGrp("savePath", q=True, text=True)
    projectPath = cmds.workspace(fn=True)

    #リファレンスファイルを入れ替えます。
    try:cmds.file(rrn,loadReference="RRN", type="mayaAscii", options= "v=0;")
    except:cmds.warning,(u"エラー")

    #保存します。
    if cmds.checkBox("save", q=True, v=True):
        currentName = cmds.file( q=True, sceneName=True, shortName=True)
        optionSel = cmds.radioCollection("options", q=True, sl=True)
    
        if optionSel =="currentName":
            savePath = savePath+"/"+currentName  
            
        if optionSel =="changeName":
            newName = cmds.textFieldButtonGrp("sceneName", q=True, text=True)
            if "." in newName:
                savePath = savePath+"/"+newName
            else:
                cmds.error(u"拡張子をつけてください")
                
        if optionSel =="changeReplaceName":
            replace_oldName = cmds.textField("old", q=True, text=True)
            replace_newName = cmds.textField("new", q=True, text=True)
            newName = currentName.replace(replace_oldName, replace_newName) 
            if newName == currentName:
                cmds.error(u"置き換える文字列は見つかりませんでした")
            savePath = savePath+"/"+newName
            
        print(savePath)               
        cmds.file(rename=savePath)
        cmds.file(f=True, save=True)
    else:
        print(u"保存を省略しました")

    #プロジェクトセットを戻します。
    if cmds.checkBox("ReturnSetProject", q=True, v=True):
        #mm.eval('setProject "%r"'%projectPath)
        cmds.workspace(projectPath, openWorkspace=True)

#UI
class MoxReplaceSave(object):
    def __init__(self):
        if cmds.window('MoxReplaceSave', exists=True):
            cmds.deleteUI('MoxReplaceSave')
            
        cmds.window('MoxReplaceSave', menuBarVisible=True, tlb=True, s=1, t="MoxReplaceSave", resizeToFitChildren=1, mnb=1, mxb=0)
        cmds.columnLayout('MainColumnLayout', adjustableColumn=True, rowSpacing=5, columnAttach=["both",5])
        
        cmds.textFieldButtonGrp("RR", l="replace reference Path", buttonLabel="path", bc="MoxReplaceSave.setPath_replace()", ann=u"リプレイスのパスです。ファイル名込みです")
        cmds.textFieldButtonGrp("savePath", l="save Scene Path", buttonLabel="path", bc="MoxReplaceSave.setPath_save()", ann=u"セーブパスです、ファイル名は不要です")
        cmds.textFieldButtonGrp("sceneName", l="new sceneName",enableButton=False,enable=False)
        
        cmds.rowLayout("changeNameWord", nc=4, cw=[1,150], en=False)
        cmds.text("changeNameWord", l="              change name word")
        cmds.textField("old", w=100)
        cmds.text(">>")
        cmds.textField("new", w=100)
        cmds.setParent("..")
        
        cmds.checkBox("ReturnSetProject", l="Return Set Project", v=True, ann=u"連続で処理をしやすいよう、最後にプロジェクトセットを戻します")
        cmds.checkBox("save", l="save", v=True, ann=u"保存をしたくないときはチェックを外してください。")
        
        cmds.separator(h=12)
        cmds.text("Scene Name Option")
        
        cmds.radioCollection("options")
        cmds.radioButton("currentName", sl=True, l=u"シーン名はそのままで保存先のみを変更")
        cmds.radioButton("changeName",  l=u"シーン名を新規", 
            onc="cmds.textFieldButtonGrp('sceneName',e=True,enable=True)", 
            ofc="cmds.textFieldButtonGrp('sceneName',e=True,enable=False)")
        cmds.radioButton("changeReplaceName", l=u"現在のシーン名の一部を置き換える",
            onc="cmds.rowLayout('changeNameWord', e=True, en=True)",
            ofc="cmds.rowLayout('changeNameWord', e=True, en=False)")
        
        cmds.button(l="run", c='MoxReplaceSave.MRS_main()')
        cmds.setParent('..')
        cmds.showWindow('MoxReplaceSave')
MoxReplaceSave_mainWind = MoxReplaceSave()